/**
 * Maa ewolucja - Gra ewolucyjno spoeczna
 *
 *	Klasa reprzentujca osobnika.
 *
 * @author Grzegorz Przytua
 */

package logic;

public class PopulationMember implements Comparable<PopulationMember> {

	/**
	 * Ile punktw zdobywa osobnik po walce przeciwko:
	 */
	protected Double vsThief;
	protected Double vsProducer;

	/**
	 * Liczba zgromdzonych przez osobnika punktw w trakcie cyklu.
	 */
	protected Double points;

	
	public PopulationMember(Double populationMembervsThief, Double populationMemberVsProducer) {
		vsThief = populationMembervsThief;
		vsProducer = populationMemberVsProducer;
		points = Params.STARTING_SPICES_POINTS;
	}

	/**
	 * Metoda realizujca gr pojedyczego spotkania.
	 */
	public <E> void fight(E opponent) {
		if (opponent instanceof Thief || opponent instanceof MutatedThief)
			points += vsThief;
		else if (opponent instanceof Producer || opponent instanceof MutatedProducer)
			points += vsProducer;
	}

	public void setPoints(Double points) {
		this.points = points;
	}

	@Override
	public String toString() {
		return "Population member " + points;
	}

	@Override
	public int compareTo(PopulationMember mem) {
		return points.compareTo(mem.points);
	}
}
